; 
    include \masm32\include\masm32rt.inc
    .686
; 
    .data
      pcFreq    dq 0
      pcCount1  dq 0
      pcCount2  dq 0
      pcCount3  dq 0
      state     dd 0
      delay     dd 0
      count     dd 0
      buffer    db 100 dup(0)
    .code
; 

Result proc hDlg:DWORD

    Switch state

      Case 0

        invoke QueryPerformanceCounter, ADDR pcCount1
        inc state

      Case 1

        invoke QueryPerformanceCounter, ADDR pcCount2
        inc state

      Case 2

        inc count
        invoke QueryPerformanceCounter, ADDR pcCount3
        finit
        fild pcCount2
        fild pcFreq
        fadd
        fild pcCount3
        fcomip st, st(1)
        .IF (!ZERO? && !PARITY? && !CARRY?)

          inc state
          fild pcCount2
          fild pcCount1
          fsub
          fild pcFreq
          fdiv
          push 1000
          fild DWORD PTR[esp]
          pop eax
          fmul
          fistp delay

          invoke wsprintf,ADDR buffer,
                          chr$("delay %dms, repeat rate %d"),
                          delay,count

          invoke SetDlgItemText,hDlg,100,ADDR buffer

        .ENDIF

      EndSw

      ret

Result endp
    
; 

DlgProc proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    Switch uMsg

      Case WM_INITDIALOG

        invoke QueryPerformanceFrequency, ADDR pcFreq

      Case WM_HSCROLL

        .IF wParam == SB_LINELEFT || SB_LINERIGHT
          invoke Result,hDlg
        .ENDIF

      Case WM_VSCROLL

        .IF wParam == SB_LINEUP || SB_LINEDOWN
          invoke Result,hDlg
        .ENDIF

      Case WM_COMMAND

        Switch wParam
        
        case 101

          invoke SetDlgItemText,hDlg,100,0
          invoke memfill,OFFSET pcCount1,132,0

        case IDCANCEL

          invoke EndDialog,hDlg,0

        EndSw

      Case WM_CLOSE

        invoke EndDialog,hDlg,0

    EndSw
    return 0
DlgProc endp
; 
start:
; 

    Dialog "Test", \
           "MS Sans Serif",10, \
            WS_OVERLAPPED or \
            WS_SYSMENU or WS_HSCROLL or WS_VSCROLL or DS_CENTER, \
            2, \
            0,0,120,90, \
            1024

    DlgStatic 0,SS_LEFT,15,20,100,10,100
    
    DlgButton "Reset",0,40,40,35,12,101

    invoke GetModuleHandle,NULL
    CallModalDialog eax,0,DlgProc,NULL

    exit
; 
end start